#include "object.h"
#include "our_colors.h"

#ifndef BADGUY_H
#define BADGUY_H

/*************Class Declaration**************/

class Badguy:public Object{
private:
	float color[4];
	float thrust;
	float GunPos[3];
	float scale;
public:
	Badguy();
	~Badguy();
	void Destroy();
	void Draw();	
	void FileWrite();
	float GetMass();
	void SetColor(float r, float g, float b, float a);
	void SetColor(float c[]);
	int GetBulletData(float locate[],float velocity[]);
	Object *Explode ();
	int TrashIt(){return 0;};
	int Points(){return 100;};
};

/****************Default Contructor*************/

Badguy::Badguy():Object()
{
  SetColor(.5,.5,.5,1);
  RotVel[0]=0;
  RotVel[1]=0;
  RotVel[2]=0;
  BadGuy=1;
  Vel[0]=(float)rand()/32767*3;
  Vel[1]=(float)rand()/32767*3;
  Vel[2]=(float)rand()/32767*3;

  thrust=2;
  GunPos[0]=0;
  GunPos[1]=0;
  GunPos[2]=-1.75;
  scale=2.;
}

/****************Destructor*************/

Badguy::~Badguy(){}

/****************************************/

void Badguy::Destroy()
{
	this->~Badguy();
}

/****************************************/

void Badguy::Draw()
{

  float p[20][3];
  int f[36][3]={{1,2,3},{1,3,4},{1,4,5},{1,5,6},{1,6,7},{1,7,2},
                {3,8,4},{5,8,6},{7,8,2},
                
		{3,10,8},{10,9,8},{9,11,8},{11,2,8},
		{12,9,10},{12,11,9},{12,10,11},
		{2,11,3},{3,11,10},
		
		{5,14,8},{14,13,8},{13,15,8},{15,4,8},
		{16,13,14},{16,15,13},{16,14,15},
                {4,15,5},{5,15,14},

		{7,18,8},{18,17,8},{17,19,8},{19,6,8},
                {20,17,18},{20,19,17},{20,18,19},
                {6,19,7},{7,19,18}};
  int i;

  float n[3]={0,0,0};
  float v1[3]={0,0,0};
  float v2[3]={0,0,0};

  VECT(0,0,-.5,p[0]);
  VECT(.433,-.25,0,p[1]);
  VECT(.433,.25,0,p[2]);
  VECT(0,.5,0,p[3]); 
  VECT(-.433,.25,0,p[4]);
  VECT(-.433,-.25,0,p[5]);
  VECT(0,-.5,0,p[6]);
  VECT(0,0,.7,p[7]);
  
  VECT(1,0,-.1,p[8]);
  VECT(.7,.3,-.2,p[9]);
  VECT(.7,-.3,-.2,p[10]);
  VECT(.6,0,-1.5,p[11]);
  
  VECT(-.5,.866,-.1,p[12]);
  VECT(-.61,.456,-.2,p[13]);
  VECT(-.09,.756,-.2,p[14]);
  VECT(-.3,.52,-1.5,p[15]);
  
  VECT(-.5,-.866,-.1,p[16]);
  VECT(-.09,-.756,-.2,p[17]);
  VECT(-.61,-.456,-.2,p[18]);
  VECT(-.3,-.52,-1.5,p[19]);
  
  
  for (i=0;i<20;i++)
    {
    LINEUP(Orient[0],Orient[1],Orient[2],p[i],v1);
    ROTATE(RotAng[0],RotAng[1],RotAng[2],v1,v2);
    p[i][0]=v2[0]/scale;
    p[i][1]=v2[1]/scale;
    p[i][2]=v2[2]/scale;
    }
     

//  fprintf(stderr,"%f %f %f\n",v1[0],v1[1],v1[2]);
     

  glPushMatrix();
  glTranslatef(Pos[0],Pos[1],Pos[2]);
  glShadeModel(GL_SMOOTH);
  glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,white);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,64);
  
 
  for (i=0;i<34;i++)
    {
    glBegin(GL_TRIANGLES);
    NORMAL(&p[f[i][0]-1][0],&p[f[i][1]-1][0],&p[f[i][2]-1][0],n);
    glNormal3fv(n);
    glVertex3fv(p[f[i][0]-1]);
    glVertex3fv(p[f[i][1]-1]);
    glVertex3fv(p[f[i][2]-1]);
    glEnd();
    }
  
  glMaterialfv(GL_FRONT_AND_BACK,GL_SPECULAR,black);
  glMaterialf(GL_FRONT_AND_BACK,GL_SHININESS,0);

  glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,black);
  
  glPopMatrix();
}

/****************************************/

void Badguy::FileWrite()
{

}

/****************************************/

float Badguy::GetMass()
{
  return (10);
}

/*****************************************/

void Badguy::SetColor(float r, float g, float b, float a)
{
  color[0]=r;
  color[1]=g;
  color[2]=b;
  color[3]=a;
}

/******************************************/

void Badguy::SetColor(float c[])
{
  color[0]=c[0];
  color[1]=c[1];
  color[2]=c[2];
  color[3]=c[3];
}

/********************************************/

int Badguy::GetBulletData(float locate[], float velocity[])
{
  //This code should not be here, but it saved us having to create
  //a new virtual function.  This is in charge of adding thrust to our
  //badguy ships so they come towards us.
      
  Vel[0]+=0;
  Vel[1]+=0;
  Vel[2]+=0;

  locate[0]=GunPos[0]/scale;
  locate[1]=GunPos[1]/scale;
  locate[2]=GunPos[2]/scale;
  float temp[3];
  LINEUP(this->Orient[0],this->Orient[1],this->Orient[2],locate,temp);
  ROTATE(this->RotAng[0],this->RotAng[1],this->RotAng[2],temp,locate);
  locate[0]+=Pos[0];
  locate[1]+=Pos[1];
  locate[2]+=Pos[2];
  velocity[0]=0;
  velocity[1]=0;
  velocity[2]=-50;
  LINEUP(this->Orient[0],this->Orient[1],this->Orient[2],velocity,temp);
  ROTATE(this->RotAng[0],this->RotAng[1],this->RotAng[2],temp,velocity);

  return 1;
}

/*********************************************/

Object * Badguy::Explode()
{
  //  this->Destroy();
  fprintf(stderr,"BADGUY EXPLODE????\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n");
  fprintf(stderr,"BADGUY POS %f %f %f\n\n\n",Pos[0],Pos[1],Pos[2]);
  return(NULL);
}

/**************************************************/

#endif
