#include "object.h"

#ifndef BOMB_H
#define BOMB_H
extern GLUquadricObj *sphereObj;

/*************Class Declaration**************/

class Bomb:public Object{
private:
	float radius;
	float color[4];
	float speed;
	float time;
	float kill_at;
public:
	Bomb(float v[]);
	~Bomb();
	void Destroy();
	void Draw();	
	void FileWrite();
	float GetMass();
	void SetColor(float r, float g, float b, float a);
	void SetColor(float c[]);
	int TrashIt(){time = time+1; if (time>kill_at) return (1); return(0);};
	Object *Explode();
};

/****************Contructor*************/

Bomb::Bomb(float v[]):Object()
{
  float wandFront[3],wandPos[3];

  CAVEGetPosition(CAVE_WAND,wandPos);
  CAVEGetVector(CAVE_WAND_FRONT,wandFront);
  speed=50;
  Vel[0]=wandFront[0]*speed+v[0];
  Vel[1]=wandFront[1]*speed+v[1];
  Vel[2]=wandFront[2]*speed+v[2];
	
  TurnGravOff();

  Pos[0]=wandFront[0]+wandPos[0];
  Pos[1]=wandFront[1]+wandPos[1];
  Pos[2]=wandFront[2]+wandPos[2];
  radius=.05;
  SetRadiusOfCollision(.05);
  Weapon=1;
  TurnGravOff();
  time=0;
  kill_at=100;
  this->SetColor(1,1,1,1);
}

/****************Destructor*************/

Bomb::~Bomb(){}

/****************************************/

void Bomb::Destroy()
{
	this->~Bomb();
}

/****************************************/

void Bomb::Draw()
{
        glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
	glPushMatrix();
	glTranslatef(Pos[0],Pos[1],Pos[2]);
	gluSphere(sphereObj,radius,4,4);   //used to be 8,8
	glPopMatrix();
}

/****************************************/

void Bomb::FileWrite()
{

}

/****************************************/

float Bomb::GetMass()
{
  return (CUBE(radius)*3/4);
}

/*****************************************/

void Bomb::SetColor(float r, float g, float b, float a)
{
  color[0]=r;
  color[1]=g;
  color[2]=b;
  color[3]=a;
}

/******************************************/

void Bomb::SetColor(float c[])
{
  color[0]=c[0];
  color[1]=c[1];
  color[2]=c[2];
  color[3]=c[3];
}

/******************************************/

Object *Bomb::Explode()
{
  //  this->Destroy();
  Bullet *piece;
  Object *list=NULL;
  Object *temp;
  int numphi=7,numtheta=12;
  int i;
  float v[3]={0,0,0};

  float points[2+(7-2)*12][3];

  //  fprintf(stderr,"computing sphere\n");

  CIRCLE_PTS(numphi,numtheta,points);

  for (i=0;i<(2+(numphi-2)*numtheta);i++)
    {
      //    fprintf(stderr,"pass %d\n",i);
    v[0]=points[i][0]*5;
    v[1]=points[i][1]*5;
    v[2]=points[i][2]*5;

    piece=new Bullet(30,v);
    //    fprintf(stderr,"got new bullet\n");

    piece->MoveRel(points[i][0]*0.1+Pos[0],points[i][1]*0.1+Pos[1],points[i][2]*0.1+Pos[2]);

    //    fprintf(stderr,"location of %d=%f %f %f\n",i,points[i][0],points[i][1],points[i][2]);

    if (!list)
      {
      list=piece;
      temp=piece;
      }
    else
      {
      temp->Link(piece);
      piece->Link(NULL);
      temp=piece;
      }
    piece=NULL;
    //    fprintf(stderr,"linked\n");
    }
  return(list);
}

#endif
