#include "object.h"

#ifndef BULLET_H
#define BULLET_H
extern GLUquadricObj *sphereObj;

/*************Class Declaration**************/

class Bullet:public Object{
private:
	float radius;
	float color[4];
	float speed;
	float time;
	float kill_at;
public:
	Bullet(float kill_time,float v[]);
	Bullet(float v[]);
	~Bullet();
	void Destroy();
	void Draw();	
	void FileWrite();
	float GetMass();
	void SetColor(float r, float g, float b, float a);
	void SetColor(float c[]);
	int TrashIt(){time = time+1; if (time>kill_at) return (1); return(0);};
	Object *Explode();
};

/****************Contructor*************/

Bullet::Bullet(float kill_time,float v[]):Object()
{
        float wandFront[3],wandPos[3];

	CAVEGetPosition(CAVE_WAND,wandPos);
	CAVEGetVector(CAVE_WAND_FRONT,wandFront);
	speed=10;
	Vel[0]=v[0];
	Vel[1]=v[1];
	Vel[2]=v[2];

	TurnGravOff();

	Pos[0]=0;
	Pos[1]=0;
	Pos[2]=0;
	radius=.02;
	SetRadiusOfCollision(.02);
	this->SetColor(1,1,1,1);
	time=0;
	kill_at=kill_time;
	Weapon=1;
}

/*********Default Constructor***********/

Bullet::Bullet(float v[]):Object()
{
  float wandFront[3],wandPos[3];

  CAVEGetPosition(CAVE_WAND,wandPos);
  CAVEGetVector(CAVE_WAND_FRONT,wandFront);
  speed=100;
  Vel[0]=wandFront[0]*speed+v[0];
  Vel[1]=wandFront[1]*speed+v[1];
  Vel[2]=wandFront[2]*speed+v[2];
	
  Pos[0]=wandFront[0]+wandPos[0];
  Pos[1]=wandFront[1]+wandPos[1];
  Pos[2]=wandFront[2]+wandPos[2];
  SetRadiusOfCollision(.025);
  radius=.025;
  time=0;
  kill_at=100;
  Weapon=1;
  TurnGravOff();
  this->SetColor(1,1,1,1);
}

/****************Destructor*************/

Bullet::~Bullet(){}

/****************************************/

void Bullet::Destroy()
{
	this->~Bullet();
}

/****************************************/

void Bullet::Draw()
{
        glMaterialfv(GL_FRONT_AND_BACK,GL_AMBIENT_AND_DIFFUSE,color);
	glPushMatrix();
	glTranslatef(Pos[0],Pos[1],Pos[2]);
	gluSphere(sphereObj,radius,4,4);   //used to be 8,8
	glPopMatrix();
}

/****************************************/

void Bullet::FileWrite()
{

}

/****************************************/

float Bullet::GetMass()
{
  return (CUBE(radius)*3/4);
}

/*****************************************/

void Bullet::SetColor(float r, float g, float b, float a)
{
  color[0]=r;
  color[1]=g;
  color[2]=b;
  color[3]=a;
}

/******************************************/

void Bullet::SetColor(float c[])
{
  color[0]=c[0];
  color[1]=c[1];
  color[2]=c[2];
  color[3]=c[3];
}

/******************************************/

Object *Bullet::Explode()
{
  return(NULL);
}

#endif
