#include <cave_ogl.h>
#include <GL/glu.h>
#include "functions.h"
#include <math.h>

#ifndef SHIELD_H
#define SHIELD_H

/********************Class Declaration************************/

class Shield:public Object{
 private:
        float energy;             //how powerful is the shield?
	float radius;             //size of the shield
	float points[500][3];     //damn, that's a lot of points
 public:
	Shield();                 //constructor
	~Shield();                //destructor
	void Destroy();           //calls destructor
	void Draw();              //DRAW
	void FileWrite(){};       //you probably know about this one
	float GetMass(){return 0;}  //the shield made out of energy, and
                                    //hence, has no mass

	Object *Explode();          //doesn't do anything
	int TrashIt(){return 0;};   //doesn't do anything
	void LoseEnergy();          //Capt'n, she can't take much more of this!
	void GainEnergy();          //Just in case we want to do this someday
	float GetEnergy();          //are we dead yet?
};

/////////////////////////////////////////////////////////////////
///// This constructor will generate the points used to draw
///// the shield (NOTE:  these points only need to be calculated
///// once, so they are done here)
Shield::Shield():Object()
{
  int i;                      //loop
  float phi,theta;            //spherical coordinates
  float p[3]={0,1,0};         //vector pointing up which will be rotated
  float temp[3]={0,0,0};      //TEMP vector


  radius=.5;                  //this is the radius of the shield/ship
  energy=1.;                  //fill'er up
  RotVel[0]=13.9334;          //let's spin this way
  RotVel[1]=30.364;           //... and this way
  RotVel[2]=-12.6934;         //... and this way
  this->TurnGravOff();        //See mass discussion above
  for (i=0;i<500;i++)         //make a whole buttload of points
    {
    phi=(float)rand()*PI/32768;     //random phi coordinate
    theta=(float)rand()*2*PI/32768; //random theta coordinate
    ROTATE(phi,0,0,p,temp);
    ROTATE(0,theta,0,temp,temp);    //rotate our p vector
    temp[0]=radius*temp[0];         //scale that vector
    temp[1]=radius*temp[1];
    temp[2]=radius*temp[2];
    
    points[i][0]=temp[0];           //store the points
    points[i][1]=temp[1];
    points[i][2]=temp[2];
    }
}

/////////////////////////////////////////////////////////////

Shield::~Shield(){}

/////////////////////////////////////////////////////////

void Shield::Destroy()
{
  this->~Shield();
}

//////////////////////////////////////////////////////////////

void Shield::Draw()
{
  int i;                   //LOOP
  float temp[3];           //TEMP

  glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,yellow);  //make the shield a 
						       //lovely dandelion color
  glPointSize(3);         //make SMALL points
  glBegin(GL_POINTS);     //MAKE POINTS
  for(i=0;i<500;i++)      //go through all points
    {
    if(rand()/32767.0 < energy)  //energy can be seen as storing the 
				 //probability that a point is on, and thus,
				 //the collection of points that are on is
				 //(energy)*100% of them
      {
      ROTATE(RotAng[0],RotAng[1],RotAng[2],points[i],temp);  //spin that shield
							     //so it looks cool
      glVertex3f(temp[0]+Pos[0],temp[1]+Pos[1],temp[2]+Pos[2]);
      }
    }
  glEnd();  //DONE
  glMaterialfv(GL_FRONT_AND_BACK,GL_EMISSION,black);  // make sure other stuff
						      // doesn't glow
  glPointSize(1);
}

/////////////////////////////////////////////////////////////////

Object *Shield::Explode()
{
  return(NULL);  //The shield never actually explodes.. this is just here for
                 //filler
}

////////////////////////////////////////////////////////////////

void Shield::LoseEnergy()
{
  energy=energy*.98;   //We've been hit!
}

///////////////////////////////////////////////////////////////

void Shield::GainEnergy()
{
  energy=energy*1.25; //We need more power!
  if (energy > 1)     //Increase shields to 105%!  >I can't do it, Cap'n!
    energy=1;
}

////////////////////////////////////////////////////////////////

float Shield::GetEnergy()
{
  return(energy);     //umm... I forget what this does
}

#endif
